From 54742b7ced559bac4eba72b45ae0c57905ae4215 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 01 2020 02:43:25 +0000
Subject: [PATCH 1124/2232] Make PtrLen usable for non-char data


---

diff --git a/gen/src/write.rs b/gen/src/write.rs
index 10c6b40..a06ab62 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -327,7 +327,7 @@ fn write_include_cxxbridge(out: &mut OutFile, apis: &[Api]) {
     if needs_trycatch || needs_rust_error {
         out.begin_block("namespace repr");
         writeln!(out, "struct PtrLen final {{");
-        writeln!(out, "  const char *ptr;");
+        writeln!(out, "  const void *ptr;");
         writeln!(out, "  size_t len;");
         writeln!(out, "}};");
         out.end_block("namespace repr");
@@ -339,7 +339,7 @@ fn write_include_cxxbridge(out: &mut OutFile, apis: &[Api]) {
         writeln!(out, "public:");
         writeln!(out, "  static Error error(repr::PtrLen repr) noexcept {{");
         writeln!(out, "    Error error;");
-        writeln!(out, "    error.msg = repr.ptr;");
+        writeln!(out, "    error.msg = static_cast<const char *>(repr.ptr);");
         writeln!(out, "    error.len = repr.len;");
         writeln!(out, "    return error;");
         writeln!(out, "  }}");

